//*****************************************************************************************//
//                                        World                                            //
//*****************************************************************************************//

#ifndef worldModule
#define worldModule 

class Object {
public:
	FaceCollection *faces;
	Object () {faces = NULL;};
	Object (FaceCollection *faces) {this->faces = faces;};
	~Object () {if (faces != NULL) deleteFaceCollection (faces);}
	virtual void log ();
	virtual void export (::ofstream &output);
};

declareCollection (Object);


class WorldcraftObject; //forward declaration

class World {
public:
	World ();
	~World ();

	ObjectCollection *objects;
	GamePoint startPosition;

	static void setup ();
	static void wrapup ();

	static World *read ();
	void export (char *filename);
	
	void add (WorldcraftObject &worldcraftObject);
	void log ();

private:
	FaceCollection *copyFaces (FaceCollection *faces);
};

#endif