//*****************************************************************************************//
//                                        Face                                             //
//*****************************************************************************************//

#ifndef faceModule
#define faceModule 

struct GamePoint {
	double x, y, z;
	double nx, ny, nz;
	double tx, ty;
};

declareCollection (GamePoint);

class Face {
public:
	//A face owns it points and texture name and therefore deletes them on its own.
	Plane plane;
	Texture *texture;
	GamePointCollection *points;

	Face () {points = NULL;};
	Face (Plane &plane, GamePointCollection *points) {
		this->plane = plane; this->points = points; texture = NULL;
	}
	~Face () {deleteGamePointCollection (points); delete [] texture;};

	void tick ();
	void draw ();
};


declareCollection (Face);

#endif