//*****************************************************************************************//
//                                        World                                            //
//*****************************************************************************************//

#ifndef worldModule
#define worldModule 

class Object {
public:
	FaceCollection *faces;
	Object () {faces = NULL;};
	Object (FaceCollection *faces) {this->faces = faces;};
	~Object () {if (faces != NULL) deleteFaceCollection (faces);}

	void tick ();
	void draw ();
};

declareCollection (Object);

class World {
public:
	ObjectCollection *objects;
	GamePoint startPosition;
	TextureCollection *textures; //This would be handy to have.

	World () {};
	~World () {};

	static void setup ();
	static void wrapup ();

	void tick ();
	void draw ();

	static World *load (); //Prompts for a file name to read a ".wrl" file from and reads it into a new world.
	void unload (); //Makes sure all textures are unloaded prior to deleting the world.
};

extern World *world;

#endif